#--*-coding:utf-8-*--

class DiceOfTheDead < DiceBot
  
  def initialize
    super
    @sendMode = 2
    @sortType = 1
    @d66Type = 2
  end
  def gameName
    'ダイス・オブ・ザ・デッド'
  end
  
  def gameType
    "DiceOfTheDead"
  end
  
  def prefixs
    ['(ZNB|BIO).*']
  end
  
  def getHelpMessage
    info = <<INFO_MESSAGE_TEXT
・ゾンビ化表　ZNB+x
（x=オープン中の感染度マスの数。+xは省略可能、省略時は0）
・感染度表　BIOx
（xは被弾回数。xは省略可能、省略時は1）
（上記二つは最初からシークレットダイスで行われます）
INFO_MESSAGE_TEXT
  end
  
  
  
  def dice_command(string, nick_e)
    
    result = ''
    output_msg = '1';
    secret_flg = false;
    
    case string
    when /(^|\s)BIO(\d+)?$/i
      result = checkInfection($2);
      output_msg = "#{nick_e}: " + result unless( result.empty? )
      secret_flg = true;
    when /(^|\s)ZNB([+](\d+))?$/i
      result = rollZombie($3);
      output_msg = "#{nick_e}: " + result unless( result.empty? )
      secret_flg = true;
    end
    
    return '1' if(output_msg == '1');
    
    return output_msg, secret_flg
  end
  
  
  def checkInfection(i)
    
    roll_times = 1
    roll_times = i.to_i  if( i.to_i != 0 )
    
    result = "感染度表"
    
    
    roll_times.times do |i|
            
        d1, = roll(1, 6)
        d2, = roll(1, 6)

        result += "　＞　出目：#{d1}、#{d2}　"
     
     if(d1<3)
           	if(d2<3)
        		result += "「右下（【足】＋１）」"
     		elsif(d2>4)
				result += "「右上（【足】＋１）」"
	 		else
	    		result += "「右中（【足】＋１）」"
	 		end
     elsif(d1>4)
           	if(d2<3)
        		result += "「左下（【頭】＋１）」"
     		elsif(d2>4)
				result += "「左上（【頭】＋１）」"
	 		else
	    		result += "「左中（【頭】＋１）」"
	 		end
	 else
           	if(d2<3)
        		result += "「中下（【腕】＋１）」"
     		elsif(d2>4)
				result += "「中上（【腕】＋１）」"
	 		else
	    		result += "「真中（【腕】＋１）」"
	 		end
	 end
	 
	 end

    return result
  end

  
  ####################
  # 各種表
  
  def rollZombie(i)
    
	value = 0
    value = i.to_i  if( i.to_i != 0 )
    
    d1, = roll(1, 6)
    d2, = roll(1, 6)

    diceTotal = d1 + d2 + value
    
    result = "ゾンビ化表　＞　出目：#{d1}＋#{d2}　感染度：#{value}　合計値：#{diceTotal}　＞　"
    
    if(diceTotal<6)
    	result += "５以下：影響なし"
    elsif(diceTotal>17)
    	result += "１８以上：自分以外の味方１人にできる限り全力で攻撃を行う。〈アイテム〉も可能な限り使用する"
    else
    
    	case diceTotal
    		when 6
    			result += "６：任意の部位を１点回復"
    		when 7
    			result += "７：〈アイテム〉武器を１つその場に落とす"
    		when 8
    			result += "８：〈アイテム〉便利道具１つをその場に落とす"
    		when 9
    			result += "９：〈アイテム〉消耗品１つをその場に落とす"
    		when 10
    			result += "１０：腕の傷が広がる。「部位：【腕】」１点ダメージ"
    		when 11
    			result += "１１：足の傷が広がる。「部位：【足】」１点ダメージ"
    		when 12
    			result += "１２：頭の傷が広がる。「部位：【頭】」１点ダメージ"
    		when 13
    			result += "１３：【ゾンビ化表】が新たに適用されるまで「【感染度】＋１マス」の効果を受ける"
    		when 14
    			result += "１４：即座に自分以外の味方１人のスロット内の〈アイテム〉１つをランダムに捨てさせる"
    		when 15
    			result += "１５：味方１人に素手で攻撃を行う"
    		when 16
    			result += "１６：即座に感染度が１上昇する"
    		when 17
    			result += "１７：次のターンのみ、すべての【能力値】を２倍にする"
			end
    
    end

    return result
  end
  
end